// Squawk messenger.
// Copyright (C) 2019  Yury Gubich <blue@macaw.me>
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.

#ifndef LMDBDATABASE_SERIALIZER_QBYTEARRAY_HPP
#define LMDBDATABASE_SERIALIZER_QBYTEARRAY_HPP

#include <QByteArray>

namespace LMDBDataBase {

template<>
class Serializer<QByteArray> {
public:
    Serializer():value() {};
    Serializer(const QByteArray& p_value):value(p_value) {};
    ~Serializer() {};

    QByteArray deserialize(const MDB_val& data) {
        value.setRawData((char*)data.mv_data, data.mv_size);
        return value;
    };
    MDB_val setData(const QByteArray& data) {
        value = data;
        return getData();
    };
    MDB_val getData() {
        MDB_val result;
        result.mv_data = value.data();
        result.mv_size = value.size();
        return result;
    };
    void clear() {
        value.clear();
    };

private:
    QByteArray value;
};

}

#endif //LMDBDATABASE_SERIALIZER_QBYTEARRAY_HPP




